/** HotelStays.java
 * Class for holding basic data of a customer
 * @author Michael Claudius, Roskilde Computer Science College
 * @version 1.0. 2011.03.09
 * Copyright 2011 by Michael Claudius
 * All rights reserved
 */
package hotelstays;

import java.util.Random;

public class HotelStays {

//Assinment 1
    Integer[][] stayTable;
    String[] rowNames = {"Jan", "Feb", "March", "Apr", "May", "June",
        "July", "Aug", "Sep", "Oct", "Nov", "Dec",};
    int rowMax, colMax, rowMin, colMin;
    Integer maximum, minimum, total, average;

    public HotelStays() {
        stayTable = new Integer[12][30];
    }

    public HotelStays(int noOfRows, int noOfColumns) {
        stayTable = new Integer[noOfRows][noOfColumns];

    }

// Assignment 2. Default initialization
    /**Initialises the table with a default value numbers
     * @param noOfStay default value of stays 
     * @return void
     */
    public void defaultStay(int noOfStays) {
        for (int row = 0; row < stayTable.length; row++) {
            for (int col = 0; col < stayTable[0].length; col++) {
                stayTable[row][col] = noOfStays;
            }
        }
    }

//Assignment 3
    public void printData() {
        for (int row = 0; row < stayTable.length; row++) {
            System.out.print(rowNames[row] + " ");
            for (int col = 0; col < stayTable[0].length; col++) {
                System.out.print(stayTable[row][col] + " ");
            }
            System.out.println();
        }
    }

// Assignment 5. Random initialization
    /**Initialises the table with random numbers
     * @param
     * @return void
     */
    public void initializeData() {
        Random r = new Random();
        for (int row = 0; row < stayTable.length; row++) {
            for (int col = 0; col < stayTable[0].length; col++) {
                stayTable[row][col] = (Integer) (r.nextInt(30));
            }
        }
    }

//Assignment 6
    /**Accumulates all stays in a the table and returns this as a string
     * Traverses the table and adds the month and all tthe row stays
     * @param void
     * @return String all salary data in a string
     */
    public String toString() {
        String s = "";
        for (int row = 0; row < stayTable.length; row++) {
            s = s + rowNames[row] + " ";
            for (int col = 0; col < stayTable[0].length; col++) {
                s = s + " " + stayTable[row][col] + " ";
            }
            s = s + "\n";
        }
        return s;
    }

// Assignment 7. Maximum value
    /**Finds and returns maximum value
     * Traverses the table and if the elements value is lower
     * then maximum and the indices of row and column are changed
     * @param
     * @return int maximum stays
     */
    public Integer findMax() {
        maximum = stayTable[0][0];
        for (int row = 0; row < stayTable.length; row++) {
            for (int col = 0; col < stayTable[0].length; col++) {
                if (maximum < stayTable[row][col]) {
                    maximum = stayTable[row][col];
                    rowMax = row;
                    colMax = col;
                }
            }
        }
        return maximum;
    }

    public Integer getMax() {
        findMax();
        return maximum;
    }

    //Assignment 8
    /**Calculates and returns the total sum of stays
     * Traverses the table and add each stay to the sum
     * @param
     * @return String total sum of stays
     */
    public Integer findTotal() {
        int sum = 0;
        for (int row = 0; row < stayTable.length; row++) {
            for (int col = 0; col < stayTable[0].length; col++) {
                sum = sum + stayTable[row][col];
            }
        }
        total = sum;
        return sum;
    }

//Assignment 9
    public Integer findAverage() {
        int number = (stayTable.length) * stayTable[0].length;
        return findTotal() / number;
    }

// Assignment 10. Minimum value
    /**Finds and returns minimum value
     * Traverses the table and if the elements value is higher
     * then minimum value and the indices of row and column are changed
     * @param
     * @return int maximum stays
     */
    public Integer findMin() {
        minimum = stayTable[0][0];
        for (int row = 0; row < stayTable.length; row++) {
            for (int col = 0; col < stayTable[0].length; col++) {
                if (minimum > stayTable[row][col]) {
                    minimum = stayTable[row][col];
                    rowMin = row;
                    colMin = col;
                }
            }
        }
        return minimum;
    }

    public Integer getMin() {
        findMin();
        return minimum;
    }

//Assignment 11
    public void statData() {
        System.out.println("Total number of stays: " + findTotal());
        System.out.println("Average number of stays: " + findAverage());
        System.out.println("Maximum stays: " + findMax()
                + " in room index: " + getColMax()
                + " in month index: " + getRowMax());
        System.out.println("Minimum stays: " + findMin()
                + " in room index: " + getColMin()
                + " in month index: " + getRowMin());
        System.out.println();
    }
    //Get and set methods for all data fields

    public Integer getAverage() {
        return average;
    }

    public void setAverage(Integer average) {
        this.average = average;
    }

    public int getColMax() {
        return colMax;
    }

    public void setColMax(int colMax) {
        this.colMax = colMax;
    }

    public int getColMin() {
        return colMin;
    }

    public void setColMin(int colMin) {
        this.colMin = colMin;
    }

    public Integer getMaximum() {
        return maximum;
    }

    public void setMaximum(Integer maximum) {
        this.maximum = maximum;
    }

    public Integer getMinimum() {
        return minimum;
    }

    public void setMinimum(Integer minimum) {
        this.minimum = minimum;
    }

    public int getRowMax() {
        return rowMax;
    }

    public void setRowMax(int rowMax) {
        this.rowMax = rowMax;
    }

    public int getRowMin() {
        return rowMin;
    }

    public void setRowMin(int rowMin) {
        this.rowMin = rowMin;
    }

    public String[] getRowNames() {
        return rowNames;
    }

    public void setRowNames(String[] rowNames) {
        this.rowNames = rowNames;
    }

    public Integer[][] getStayTable() {
        return stayTable;
    }

    public void setStayTable(Integer[][] stayTable) {
        this.stayTable = stayTable;
    }

    public Integer getTotal() {
        return total;
    }

    public void setTotal(Integer total) {
        this.total = total;
    }

    public void setStays(Integer stay, int row, int col) {
        stayTable[row][col] = stay;
    }

    public Integer getStays(int row, int col) {
        return stayTable[row][col];
    }
}
